import 'package:flutter/material.dart';
import 'dart:async';

import 'package:flutter/services.dart';
import 'package:hls_player/hls_player.dart';

void main() => runApp(MyApp());

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  @override
  void initState() {
    super.initState();
    // initPlatformState();
    // initZappingPlatformState();
  }

  // Platform messages are asynchronous, so we initialize in an async method.
  static Future<void> initPlatformState() async {
    const uRL_VIDEO =
        "http://200.23.206.107:18080/canales/miscelaneos/docubox/playlist.m3u8";

    try {
      await HlsPlayer.initializeVideo(url: uRL_VIDEO).then((onValue) {
        print(onValue);
      }).catchError((onError) {
        print(onError);
      });
    } on PlatformException {}
  }

  static Future<void> initZappingPlatformState() async {
    const uRL_VIDEO =
        "http://200.23.206.107:18080/canales/miscelaneos/docubox/playlist.m3u8";
    const uRL_VIDEO2 = "http://mdstrm.com/video/5a29c07e5522e40a45beb669.m3u8";
    const uRL_VIDEO3 =
        "http://unlimited1-cl.dps.live/campustv/campustv.smil/playlist.m3u8";

    final canales = [uRL_VIDEO, uRL_VIDEO2, uRL_VIDEO3];

    try {
      await HlsPlayer.initializeZapping(canales: canales, playVideoAtIndex: 0)
          .then((onValue) {
        print(onValue);
        Timer.periodic(
            Duration(seconds: 5), (Timer t) => initGetVideoLink(canales));
      }).catchError((onError) {
        print(onError);
      });
    } on PlatformException {}
  }

  static Future<void> initGetVideoLink(List canales) async {
    try {
      await HlsPlayer.getVideoLink(canales: canales).then((onValue) {
        print(onValue);
      }).catchError((onError) {
        print(onError);
      });
    } on PlatformException {}
  }

  Widget testWidget = new MediaQuery(
    data: new MediaQueryData(),
    child: new MaterialApp(
      home: Scaffold(
          body: Column(
        children: <Widget>[
          RaisedButton(
            child: Text(
              'play video',
              style: TextStyle(fontSize: 18.0),
            ),
            onPressed: () {
              initPlatformState();
            },
          ),
          RaisedButton(
            child: Text(
              'play videos zapping',
              style: TextStyle(fontSize: 18.0),
            ),
            onPressed: () {
              initZappingPlatformState();
            },
          ),
        ],
      )),
    ),
  );

  @override
  Widget build(BuildContext context) {
    return testWidget;
  }
}
